package com.qxtop.wc;

import org.apache.flink.api.common.functions.FlatMapFunction;
import org.apache.flink.api.java.functions.KeySelector;
import org.apache.flink.api.java.tuple.Tuple2;
import org.apache.flink.streaming.api.datastream.DataStreamSource;
import org.apache.flink.streaming.api.datastream.KeyedStream;
import org.apache.flink.streaming.api.datastream.SingleOutputStreamOperator;
import org.apache.flink.streaming.api.environment.StreamExecutionEnvironment;
import org.apache.flink.util.Collector;

public class WordCountStreamDemo {

   public static void main(String[] args) throws Exception {
      StreamExecutionEnvironment env = StreamExecutionEnvironment.getExecutionEnvironment();
      DataStreamSource fileDs = env.readTextFile("input/words.txt");
      SingleOutputStreamOperator wordAndOneDs = fileDs.flatMap(new FlatMapFunction() {
         public void flatMap(String value, Collector out) throws Exception {
            String[] words = value.split(" ");
            String[] var4 = words;
            int var5 = words.length;

            for(int var6 = 0; var6 < var5; ++var6) {
               String word = var4[var6];
               Tuple2 wordTupe2 = Tuple2.of(word, Integer.valueOf(1));
               out.collect(wordTupe2);
            }

         }
      });
      KeyedStream wordAndOneKs = wordAndOneDs.keyBy(new KeySelector() {
         public String getKey(Tuple2 value) throws Exception {
            return (String)value.f0;
         }
      });
      SingleOutputStreamOperator sum = wordAndOneKs.sum(1);
      sum.print();
      env.execute();
   }
}
